Security Considerations for SRv6 Networks
Cheng Li
Huawei
China
c.l@huawei.com
Zhenbin Li
Huawei
China
lizhenbin@huawei.com
Chongfeng Xie
China Telecom
China Telecom Information Science&Technology Innovation park, Beiqijia Town,Changping District
Beijing
China
xiechf@chinatelecom.cn
Hui Tian
CAICT
Beijing
China
tianhui@caict.ac.cn
Jianwei Mao
Huawei
China
MaoJianwei@huawei.com
22 April 2022
Routing
Spring
Segment Routing, Security
SRv6 inherits potential security vulnerabilities from Source Routing in general, and also from IPv6. This document describes various threats and security concerns related to SRv6 networks and existing approaches to solve these threats.

Introduction
Segment Routing (SR) [RFC8402] is a source routing paradigm that explicitly indicates the forwarding path for packets at the source node by inserting an ordered list of instructions, called segments. A segment can represent a topological or service-based instruction.
When segment routing is deployed on IPv6 [RFC8200] dataplane, called SRv6 [RFC8754], a segment is a 128 bit value, and can the IPv6 address of a local interface but it does not have to. For supporting SR, a new type of Routing Extension Header is defined and called the Segment Routing Header (SRH). The SRH contains a list of SIDs and other information such as Segments Left. The SRH is defined in [RFC8754]. By using the SRH, an ingress router can steer SRv6 packets into an explicit forwarding path so that many use cases like Traffic Engineering, Service Function Chaining can be deployed easily by SRv6.
However, SRv6 also brings some new security concerns. This document describes various threats to networks deploying SRv6. SRv6 inherits potential security vulnerabilities from source routing in general, and also from IPv6.
- SRv6 makes use of the SRH which is a new type of Routing Extension Header. Therefore, the security properties of the Routing Extension Header are addressed by the SRH. See [RFC5095] and [RFC8754] for details.
- SRv6 consists of using the SRH on the IPv6 dataplane which security properties can be understood based on previous work [RFC4301], [RFC4302], [RFC4303] and [RFC4942].
In this document, we will consider the dangers from the following kinds of threats:
- Wiretapping/eavesdropping
- Packet Falsification
- Identity Spoofing
- Packet Replay
- DOS/DDOS
- Malicious Packet Data
The rest of this document describes the above security threats in SRv6 networks and existing approaches to mitigate and avoid the threats.

Terminology
This document uses the terminology defined in [RFC5095] and [RFC8754].

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

Security Principles of SRv6 Networking
As with other similar source-routing architectures, an attacker may manipulate the traffic path by modifying the packet header. SPRING architecture [RFC8402] allows clear trust domain boundaries so that source-routing information is only usable within the trusted domain and never exposed to the outside world. It is expected that, by default, explicit routing is only used within the boundaries of the administered domain. Therefore, the data plane does not expose any source-routing information when a packet leaves the trusted domain. Traffic is filtered at the domain boundaries [RFC8402].
Unless otherwise noted, the discussion in this document pertain to SR networks which can be characterized as "trusted domains", i.e., the SR routers in the domain are presumed to be operated by the same administrative entity without malicious intent and also according to specifications of the protocols that they use in the infrastructure.
This document assumes that the SR-capable routers and transit IPv6 routers within the SRv6 trusted domains are trustworthy. Hence, the SRv6 packets are treated as normal IPv6 packets in transit nodes and the SRH will not bring new security problem. The security considerations of IPv6 networks are out of scope of this document.

Types of Vulnerabilities in SR Networks
This section outlines in details the different types of vulnerabilities listed in Section 1. Then, for each type, an attempt to determine whether or not the vulnerability exists in a trusted domain is made.

Eavesdropping Vulnerabilities in SRv6 Networks
As with practically all kinds of networks, traffic in an SRv6 network may be vulnerable to eavesdropping.
- Threats: Eavesdropping
- Solutions: Encapsulating Security Payload (ESP, [RFC4303]) can be used in order to prevent Eavesdropping. The ESP header is either inserted between the IP header and the next layer(transport) protocol header, or before an encapsulated IP header (tunnel mode). ESP can be used in order to provide confidentiality, data origin authentication, connectionless integrity, an anti-replay service (a form of partial sequence integrity), and (limited) traffic flow confidentiality. The set of services provided depends on the selected options at the time of the Security Association (SA) establishment and on the location of the implementation in a network topology.(add reference to the different points explained in this paragraph).
- Conclusion: In tunnel mode of ESP, packets are encrypted and can not be eavesdropped in a trusted SRv6 domain. In transport mode of ESP, the payload of packets are encrypted and cannot be eavesdropped in a trusted SRv6 domain, even if the IPv6 and SRH headers are not encrypted.
- Gaps: The IPv6 and SRH headers are not encrypted in transport mode of ESP which may be eavesdropped by attackers.

Transport Mode ESP for SRv6 packets

+------------------------------------------------------------------+
|IPv6 Header| SRH | ESP|     Payload       |ESP Tail| ESP Auth data|
+------------------------------------------------------------------+
                       |----- Encryption Scope -----|
                  |------ Authentication Scope -----|

Tunnel Mode ESP for SRv6 packets
+----------------------------------------------------------------------+
|New IPv6 Header|SRH|ESP|IPv6 Header|SRH|Payload|ESP Tail|ESP Auth data|
+----------------------------------------------------------------------+
                        |------ Encryption Scope --------|
                    |------- Authentication Scope -------|

Packet Falsification in SRv6 Networks
As SRv6 domain is a trusted domain, there is no Packet Falsification within the SRv6 domain.
As the packets from outside of SRv6 domain cannot be trusted, an Integrity Verification policy is typically deployed at the external interfaces of the ingress SRv6 routers in order to verify the incoming packets (i.e., from outside of SRv6 domain [RFC8986]). Also, the packets with SRH sent form hosts within the SRv6 domain should be verified in order to prevent the falsification between the host and the ingress router. [RFC8986].
- Threats: Packet Falsification
- Solutions: The packets from outside can not be trusted, so Integrity Verification policy should be deployed at the external interfaces by using , e.g., IPSec [RFC4301] (AH [RFC4302], ESP [RFC4303] ) or HMAC [RFC2104]. AH [RFC4302], ESP [RFC4303] and HMAC [RFC2104] can provide Integrity Verification for packets, while the ESP can encrypt the payload in order to provide higher security. However, it has been noted that the AH and ESP are not directly applicable in order to reduce the vulnerabilities of SRv6 due to the presence of mutable fields in the SRH. In order to solve this problem, [RFC8754] defines a mechanism in order to carry HMAC TLV in the SRH so to verify the integrity of packets including the SRH fields. The HMAC TLV is usually processed based on the local policy, only at the ingress router. Within the SRv6 domain, the packets are trusted, so HMAC TLV is typically ignored. In other words, the segment list is mutable within the SRv6 domain but cannot be changed before processing the HMAC TLV.
- Conclusions: There is no Packet Falsification within a trusted SRv6 domain. Integrity Verification policy like HMAC processing should be deployed at the external interfaces of the ingress SRv6 routers filtering SRH packets from outside the trusted domain and SRH packets from hosts within the SRv6 domain.
- Gaps: IPsec cannot provide verification for SRH.

Transport Mode AH and HMAC for SRv6 packets

+-----------------------------------------------------------------+
|IPv6 Header   | SRH | AH|     Payload                            |
+-----------------------------------------------------------------+

|--Auth Scope--|HMAC |---------------Auth Scope-------------------|

Tunnel Mode AH and HMAC for SRv6 packets

+-----------------------------------------------------------------+
|New IPv6 Header|SRH | AH |IPv6 Header|SRH|Payload                |
+-----------------------------------------------------------------+
|--Auth Scope---|HMAC|---------------Auth Scope-------------------|

Identity Spoofing in SRv6 Networks
The same as for Packet Falsification, there is no Identity Spoofing possible within the boundaries of a SRv6 trusted domain where all nodes are under control of the same administrative organization.
Authentication policy should be deployed at the external interfaces of the ingress SRv6 routers in order to validate the packets from outside of SRv6 domain [RFC8986]. Also, the packets with SRH sent form hosts inside the SRv6 domain should be validated in order to prevent the Identity Spoofing [RFC8986].
- Threats: Identity Spoofing
- Solutions: IPSec [RFC4301] (AH [RFC4302], ESP [RFC4303] ) or HMAC [RFC2104] can be used for Authentication. AH, ESP and HMAC can provide Authentication of source node, while the ESP can encrypt the payload in order to provide higher security. Same as section 3.2.
- Conclusion: There is no Identity Spoofing within a trusted SRv6 domain. Identity Spoofing policy should be deployed on the external interfaces of the ingress SRv6 routers for the packets from outside and the packets with SRH from hosts within the SRv6 domain.
- Gaps: TBA

Packet Replay in SRv6 Networks
There are no new Packet Replay threat brought by SRH. ESP can be applied to SRv6 in order to prevent Packet replay attacks.
- Threats: Packet Replay
- Solutions: ESP [RFC4303] can be used to prevent Replay Attacks.
- Conclusion: There are no new Packet Replay threat brought by SRH. ESP can be applied to SRv6 in order to prevent Packet replay attacks.
- Gaps: TBD

DOS/DDOS in SRv6 Networks
The generation of ICMPv6 error messages may be used in order to attempt DOS(Denial-Of-Service)/DDOS(Distributed Denial-Of-Service) attacks by sending an error-causing destination address or SRH in back-to-back packets [RFC8754]. An implementation that correctly follows Section 2.4 of [RFC4443] would be protected by the ICMPv6 rate-limiting mechanism also in the case of packets with an SRH.
- Threats: DOS/DDOS
- Solutions: ICMPv6 rate-limiting mechanism as defined in [RFC4443]
- Conclusions: There are no DOS/DDOS threats within SRv6 domain, the threats come from outside of the domain, and can be prevented by ICMPv6 rate-limiting mechanism.
- Gaps: TBD

Malicious Packet Data in SRv6 Networks
TBA

Effects of the above on SRv6 Use Cases
This section describes the effects of the above-mentioned vulnerabilities in terms of applicability statement and the use cases given in citation.
TBA.

Security Policy Design
The basic security for intra-domain deployment is described in [RFC8986] and the enhanced security mechanism is defined in [RFC8754].
In [RFC8986], additional basic security mechanisms are defined. For easier understanding, a easy example is shown in Figure 5.

SRv6 Security Policy Design

        ***************************              *****
        *             (3) h2      *              *   * SRv6 domain
        *               \ |       *              *****
 h1-----A-----B-----C-----D-------E-------F
      / *    (2)    (2)  (2)      * \
(1,2,3) *                         *  (1,2)
        *                         *
        ***************************

- A-E: SRv6 Routers inside the SRv6 domain, A and E are the edge router, can be called Ingress router instead.
- F: Router F outside the SRv6 domain.
- h1: A host outside the SRv6 domain connects to router Router A.
- h2: A host within SRv6 domain, which connects to the Router D.
- (1): Security policy 1: ACL for External Interface.
- (2): Security policy 2: ACL for Internal Interfaces.
- (3): Security policy 3: Policy for processing HMAC, should be deployed at the ingress nodes.

Basic Security Design

ACL for External Interfaces
Typically, in any trusted domain, ingress routers are configured with Access Control Lists (ACL) filtering out any packet externally received with SA/DA having a domain internal address. An SRv6 router typically comply with the same rule.
A provider would generally do this for its internal address space in order to prevent access to internal addresses and in order to prevent spoofing. The technique is extended to the local SID space. However, in some use cases, Binding SID can be leaked outside of SRv6 domain. Detailed ACL should be then configured in order to consider the externally advertised Binding SID.

ACL for Internal Interfaces
An SRv6 router MUST support an ACL with the following behavior:
1. IF (DA == LocalSID) && (SA != internal address or SID space) :
2.    drop

This prevents access to locally instantiated SIDs from outside the operator's infrastructure. Note that this ACL may not be enabled in all cases. For example, specific SIDs can be used to provide resources to devices that are outside of the operator's infrastructure.

SID Instantiation
As per the End definition [RFC8986], an SRv6 router MUST only implement the End behavior on a local IPv6 address if that address has been explicitly enabled as an SRv6 SID.
Packets received with destination address representing a local interface that has not been enabled as an SRv6 SID MUST be dropped.

Enhanced Security Design
HMAC [RFC2104] is the enhanced security mechanism for SRv6 as defined in [RFC8754]. HMAC is used for validating the packets with SRH sent from hosts within SRv6 domain.
Since the SRH is mutable in computing the Integrity Check Value (ICV) of AH [RFC8754], so AH can not be directly applicable to SRv6 packets. HMAC TLV in SRH is used for making sure that the SRH fields like SIDs are not changed along the path. While the intra SRv6 domain is trustworthy, so HMAC will be processed at the ingress nodes only, and could be ignore at the other nodes inside the trusted domain.

Security Considerations
TBA

Acknowledgements
Manty thanks to Charles Perkins and Stefano Previdi's valuable comments.

Normative References

Informative References
[RFC8402]
[RFC8200]
[RFC8754]
[RFC5095]
[RFC4301]
[RFC4302]
[RFC4303]
[RFC4942]
[RFC2119]
[RFC8174]
[RFC8986]
[RFC2104]
[RFC4443]